package scalapi.jdk.net

import java.net.InetAddress.getLocalHost
import java.net.ServerSocket
import scalapi.jdk.Implicits._

object Sockets {

  val unixMaxReservedPort = 1024

  val unixFirstNotReservedPort = unixMaxReservedPort + 1

  def findAvailablePort[T](serverCreator: Int => T): T = {
    val maxServerAcquisitionAttempts = 10
    var currentServerAcquisitionAttempt = 1
    var server = null.asInstanceOf[T]
    while (currentServerAcquisitionAttempt <= maxServerAcquisitionAttempts) {
      try {
        val port = new ServerSocket(0, 0, getLocalHost).use {
          _.getLocalPort
        }
        server = serverCreator(port)
        currentServerAcquisitionAttempt = currentServerAcquisitionAttempt + 1
      } catch {
        case e: Exception =>
      }
    }
    if (server == null) {
      throw new IllegalStateException("Cannot acquire server (after %s attempts).".format(maxServerAcquisitionAttempts))
    }
    server
  }

}
